*-- FP2Cust2.prg 
*-- Print a Customer List
*--
*-- Demonstrates the following tips & tricks
*--
*-- Suppress the "Printing..." dialog
*-- Did the user cancel printing?
*-- Print "Page x of y"

* Open File
SELECT 0
USE customer
SET ORDER TO comp_name
GOTO TOP

* Initialize variables
PRIVATE lPhantom, lPrinted, nPages, cTemp
lPrinted = .f.
nPages = 0
cTemp = SUBSTR(SYS(2015), 3, 10) + '.txt'

* Prompt for the printer
=SYS(1037)

* Print the Phantom report
WAIT WINDOW 'Calculating total number of pages ...' NOWAIT
lPhantom = .t.
REPORT FORM fp2cust2 NOCONSOLE TO FILE &cTemp
nPages = _PAGENO
ERASE (cTemp)
lPhantom = .f.
WAIT CLEAR

* Print the real report
IF lPrinted 
  REPORT FORM fp2cust2 NOCONSOLE TO PRINTER 
ENDIF

* Close file
USE

*****************
FUNCTION Suppress
*****************
* Suppresses the "Printing..." dialog
IF WEXIST('Printing...')
  MOVE WINDOW 'Printing...' TO -1000, -1000
ENDIF
RETURN ''

****************
FUNCTION Printed
****************
* Update lPrinted flag
IF lPhantom
  lPrinted = .t.
ENDIF
RETURN ''

 