*-- VFPCust2.prg 
*-- Print a Customer List
*--
*-- Demonstrates the following tips & tricks
*--
*-- Suppress the "Printing..." dialog
*-- Did the user cancel printing?
*-- Print "Page x of y"

* Initialize variables
PRIVATE lPhantom, lPrinted, nPages, cTemp
lPrinted = .f.
nPages = 0
cTemp = SUBSTR(SYS(2015), 3, 10) + '.txt'

* Prompt for the printer
=SYS(1037)

* Print the Phantom report
WAIT WINDOW 'Calculating total number of pages ...' NOWAIT
lPhantom = .t.
REPORT FORM vfpcust2 NOCONSOLE TO FILE &cTemp
nPages = _PAGENO
ERASE (cTemp)
lPhantom = .f.
WAIT CLEAR

* Print the real report
IF lPrinted 
  REPORT FORM vfpcust2 NOCONSOLE TO PRINTER PREVIEW
ENDIF

******************
PROCEDURE Suppress
******************
* Suppresses the "Printing..." dialog
IF WEXIST('Printing...')
  MOVE WINDOW 'Printing...' TO -1000, -1000
ENDIF
RETURN

*****************
PROCEDURE Printed
*****************
* Update lPrinted flag
IF lPhantom
  lPrinted = .t.
ENDIF
RETURN

 